#pragma once

#include "CoreMinimal.h"
#include "LMWeaponDataStructure.h"
#include "LMWeapon.generated.h"

struct FLMWeaponDataStructure;

UCLASS(BlueprintType, Blueprintable)
class LEGUMEMIX_API ULMWeapon : public UObject
{
	GENERATED_BODY()

public:
	
	UPROPERTY()
	FLMWeaponDataStructure WeaponDataStructure;
	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category = "Legumix")
	FDataTableRowHandle WeaponRow;

	UPROPERTY()
	int CurrentClipAmmo;

	UPROPERTY()
	int CurrentAmmoInInventory;

	void Initialize();
	
	void Fire();
	UFUNCTION(BlueprintCallable)
	void Reload();
	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent)
	void OnReload(); //To call in blueprint for design utilities
	void AddAmmo();

	bool HasAmmoInClip();
	bool HasAmmoInInventory();
};
